#include <stdio.h>
#include "nv_emul.h"
#include "utils.h"

int CGuardantEmul::nskCheck()
{
	wchar_t buf[100];
	UNICODE_STRING KeyName = {100, 100, buf};
	OBJECT_ATTRIBUTES oa;
	HANDLE hKey;
	NTSTATUS res;

	swprintf(KeyName.Buffer, L"Guardant\\%X", m_privateKey);
	KeyName.Length = wcslen(KeyName.Buffer) * 2;

	InitializeObjectAttributes(&oa, &KeyName, OBJ_CASE_INSENSITIVE, hMainKey, NULL);

	res = ZwOpenKey(&hKey, KEY_QUERY_VALUE, &oa);

	if (NT_SUCCESS(res))
	{
		ZwClose(hKey);
		return 0;
	}
	else
		return 1;
}

void CGuardantEmul::nskEnvelope(ULONG *Question)
{
	wchar_t temp[100], temp2[20];
	UNICODE_STRING KeyName = {100, 100, temp};
	UNICODE_STRING ValName = {16, 20, temp2};

	OBJECT_ATTRIBUTES oa;
	HANDLE hKey;
	PKEY_VALUE_PARTIAL_INFORMATION ppi = NULL;
	ULONG cb = 0, res = 0;

	swprintf(KeyName.Buffer, L"Guardant\\%X\\Envelope", m_privateKey);
	KeyName.Length = wcslen(KeyName.Buffer) * 2;

	InitializeObjectAttributes(&oa, &KeyName, OBJ_CASE_INSENSITIVE, hMainKey, NULL);
	
	if (STATUS_SUCCESS == ZwOpenKey(&hKey, KEY_QUERY_VALUE, &oa))
	{
		swprintf(ValName.Buffer, L"%.8X", *Question);
		ZwQueryValueKey(hKey, &ValName, KeyValuePartialInformation, NULL, 0, &cb);
		if (cb)
		{
			ppi = (PKEY_VALUE_PARTIAL_INFORMATION)ExAllocatePool(PagedPool, cb);
			if (ppi)
			{
				if (STATUS_SUCCESS == ZwQueryValueKey(hKey, &ValName, KeyValuePartialInformation, ppi, cb, &cb))
					if ((ppi->Type == REG_DWORD) && (ppi->DataLength == 4))
						RtlCopyBytes(Question, &(ppi->Data[0]), 4);
				ExFreePool(ppi);
			}
		}
		ZwClose(hKey);
	}
}

void CGuardantEmul::nskCodeInit(unsigned char *buf)
{
	wchar_t temp[100], temp2[100];
	UNICODE_STRING KeyName = {100, 100, temp};
	UNICODE_STRING ValName = {100, 100, temp2};
	ANSI_STRING tmp;

	OBJECT_ATTRIBUTES oa;
	HANDLE hKey;
	PKEY_VALUE_PARTIAL_INFORMATION ppi = NULL;
	ULONG cb = 0, res = 0;

	swprintf(KeyName.Buffer, L"Guardant\\%X\\CodeInit", m_privateKey);
	KeyName.Length = wcslen(KeyName.Buffer) * 2;

	InitializeObjectAttributes(&oa, &KeyName, OBJ_CASE_INSENSITIVE, hMainKey, NULL);
	
	if (STATUS_SUCCESS == ZwOpenKey(&hKey, KEY_QUERY_VALUE, &oa))
	{
		RtlInitAnsiString(&tmp, (char *)buf);
		RtlAnsiStringToUnicodeString(&ValName, &tmp, FALSE);

		ZwQueryValueKey(hKey, &ValName, KeyValuePartialInformation, NULL, 0, &cb);
		if (cb)
		{
			ppi = (PKEY_VALUE_PARTIAL_INFORMATION)ExAllocatePool(PagedPool, cb);
			if (ppi)
			{
				if (STATUS_SUCCESS == ZwQueryValueKey(hKey, &ValName, KeyValuePartialInformation, ppi, cb, &cb))
					if ((ppi->Type == REG_BINARY) && (ppi->DataLength == 32))
						RtlCopyBytes(buf, &(ppi->Data[0]), 32);
				ExFreePool(ppi);
			}
		}
		ZwClose(hKey);
	}
}

void CGuardantEmul::nskReadUAM(ULONG position, int size, unsigned char *buf)
{
	unsigned char isFidus = 0;
	nskReadSAM(0, 1, &isFidus);
	if (isFidus != 2)
	  position += 30;
	else
	{
		#if DBG
		DbgPrint("==DongleFilter> nskReadUAM>> Fidus! %i", isFidus);
		#endif
	}
	nskReadSAM(position, size, buf);
}

void CGuardantEmul::nskReadSAM(ULONG position, int size, unsigned char *buf)
{
	wchar_t temp[100];
	UNICODE_STRING ValName = {12, 12, L"Memory"};
	UNICODE_STRING KeyName = {100, 100, temp};

	OBJECT_ATTRIBUTES oa;
	HANDLE hKey;
	PKEY_VALUE_PARTIAL_INFORMATION ppi = NULL;
	ULONG cb = 0;

	swprintf(KeyName.Buffer, L"Guardant\\%X", m_privateKey);
	KeyName.Length = wcslen(KeyName.Buffer) * 2;

	InitializeObjectAttributes(&oa, &KeyName, OBJ_CASE_INSENSITIVE, hMainKey, NULL);

	if (STATUS_SUCCESS == ZwOpenKey(&hKey, KEY_QUERY_VALUE, &oa))
	{
		ZwQueryValueKey(hKey, &ValName, KeyValuePartialInformation, NULL, 0, &cb);
		if (cb)
		{
			ppi = (PKEY_VALUE_PARTIAL_INFORMATION)ExAllocatePool(PagedPool, cb);
			if (ppi)
			{
				if (STATUS_SUCCESS == ZwQueryValueKey(hKey, &ValName, KeyValuePartialInformation, ppi, cb, &cb))
				{
	                                FullDecode((BYTE *)&ppi->Data[0], ppi->DataLength);
					if ((ppi->Type == REG_BINARY) && (ppi->DataLength >= position + size))
						RtlCopyBytes(buf, ppi->Data + position, size);
				}
				ExFreePool(ppi);
			}
		}
		ZwClose(hKey);
	}
}

void CGuardantEmul::nskTransform(ULONG position, unsigned char *buf)
{
	wchar_t temp[100];
	UNICODE_STRING FileName = {0, 100, temp}; 

	OBJECT_ATTRIBUTES oa;
	IO_STATUS_BLOCK iosb;
	FILE_STANDARD_INFORMATION fsi;
	HANDLE hFile;
	NTSTATUS status;
	LARGE_INTEGER Offset;

	swprintf(FileName.Buffer, L"\\SystemRoot\\system32\\drivers\\%X.bin", m_privateKey);
	FileName.Length = wcslen(FileName.Buffer) * 2;

	InitializeObjectAttributes(&oa, &FileName, OBJ_CASE_INSENSITIVE, NULL, NULL);
	status = ZwCreateFile(&hFile, FILE_READ_DATA | SYNCHRONIZE, &oa, &iosb, NULL, FILE_ATTRIBUTE_NORMAL, 
		FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, FILE_OPEN, FILE_SYNCHRONOUS_IO_NONALERT, NULL, 0);
	
	if(STATUS_SUCCESS == status)
	{
		status = ZwQueryInformationFile(hFile, &iosb, &fsi, sizeof(fsi), FileStandardInformation);
		if(STATUS_SUCCESS == status)
		{
			if(fsi.EndOfFile.LowPart >= position * 4 + 4)
			{
				RtlZeroMemory(buf, 4);
				Offset.LowPart = position * 4;
				Offset.HighPart = 0;
				status = ZwReadFile(hFile, NULL, NULL, NULL, &iosb, buf, 4, &Offset, NULL);

				LARGE_INTEGER delay;
				delay.HighPart = -1;
				delay.LowPart = -1500000;
				KeDelayExecutionThread(KernelMode, FALSE, (LARGE_INTEGER *)&delay);
			}
		}
		ZwClose(hFile);
	}
}

void CGuardantEmul::nskFind(ULONG inPrivateKey, unsigned char *buf)
{
	m_privateKey = inPrivateKey;
	ns_ChkNSK *buf_chk = (ns_ChkNSK *)buf;
	nskReadSAM(14, 4, (unsigned char *)&buf_chk->dw_kmPublicCode);
	nskReadSAM(18, 1, (unsigned char *)&buf_chk->b_kmHrwVersion);
	nskReadSAM(19, 1, (unsigned char *)&buf_chk->b_kmLANRes);
	nskReadSAM(20, 2, (unsigned char *)&buf_chk->w_kmType);
	nskReadSAM(22, 4, (unsigned char *)&buf_chk->dw_kmID);
	nskReadSAM(30, 1, (unsigned char *)&buf_chk->b_kmNProg);
	nskReadSAM(31, 1, (unsigned char *)&buf_chk->b_kmVer);
	nskReadSAM(32, 2, (unsigned char *)&buf_chk->w_kmSN);
	nskReadSAM(34, 2, (unsigned char *)&buf_chk->w_kmMask);
	nskReadSAM(35, 2, (unsigned char *)&buf_chk->w_kmGP);
	nskReadSAM(38, 2, (unsigned char *)&buf_chk->w_kmRealLANRes);
	nskReadSAM(40, 4, (unsigned char *)&buf_chk->dw_kmIndex);
}

void CGuardantEmul::PrintBuffer(unsigned char *buf, int size)
{
	#if DBG
	int c = 1;
	for (; c <= size; ++c)
	{
		DbgPrint("%.2X ", buf[c - 1]);
		if (c%25 == 0) DbgPrint("\n");
	}
	DbgPrint("\n");
	#endif
}

void CStealthAptusEmul::nskReadUAM(ULONG position, int size, unsigned char *buf)
{
	unsigned char isFidus = 0;
	nskReadSAM(0, 1, &isFidus);
	if (isFidus != 2)
	  position += 30;
	else
	{
		#if DBG
		DbgPrint("==DongleFilter> nskReadUAM>> Fidus! %i", isFidus);
		#endif
	}
	nskReadSAM(position, size, buf);
}

void CStealthAptusEmul::nskReadSAM(ULONG position, int size, unsigned char *buf)
{
	wchar_t temp[100];
	UNICODE_STRING ValName = {12, 12, L"Memory"};
	UNICODE_STRING KeyName = {100, 100, temp};

	OBJECT_ATTRIBUTES oa;
	HANDLE hKey;
	PKEY_VALUE_PARTIAL_INFORMATION ppi = NULL;
	ULONG cb = 0;

	swprintf(KeyName.Buffer, L"Guardant\\%s", m_privateKey);
	KeyName.Length = wcslen(KeyName.Buffer) * 2;

	InitializeObjectAttributes(&oa, &KeyName, OBJ_CASE_INSENSITIVE, hMainKey, NULL);

	if (STATUS_SUCCESS == ZwOpenKey(&hKey, KEY_QUERY_VALUE, &oa))
	{
		ZwQueryValueKey(hKey, &ValName, KeyValuePartialInformation, NULL, 0, &cb);
		if (cb)
		{
			ppi = (PKEY_VALUE_PARTIAL_INFORMATION)ExAllocatePool(PagedPool, cb);
			if (ppi)
			{
				if (STATUS_SUCCESS == ZwQueryValueKey(hKey, &ValName, KeyValuePartialInformation, ppi, cb, &cb))
				{
	                                FullDecode((BYTE *)&ppi->Data[0], ppi->DataLength);
					if ((ppi->Type == REG_BINARY) && (ppi->DataLength >= position + size))
						RtlCopyBytes(buf, ppi->Data + position, size);
				}
				ExFreePool(ppi);
			}
		}
		ZwClose(hKey);
	}
}

int CStealthAptusEmul::nskCheck()
{
	wchar_t buf[100];
	UNICODE_STRING KeyName = {100, 100, buf};
	OBJECT_ATTRIBUTES oa;
	HANDLE hKey;
	NTSTATUS res;

	swprintf(KeyName.Buffer, L"Guardant\\%s", m_privateKey);
	KeyName.Length = wcslen(KeyName.Buffer) * 2;

	InitializeObjectAttributes(&oa, &KeyName, OBJ_CASE_INSENSITIVE, hMainKey, NULL);

	res = ZwOpenKey(&hKey, KEY_QUERY_VALUE, &oa);

	if (NT_SUCCESS(res))
	{
		ZwClose(hKey);
		return 0;
	}
	else
		return 1;
}
